functor DebugUtils(
	    structure WrMgt: WRMGT
	    structure ListUtils: LISTUTILS
	    ) : DEBUGUTILS = struct

open WrMgt
open Pp;

val level = ref(0);

fun reset_debugutils () = (level := 0)

fun unwind_protect f cleanup =
  (f())
  handle e => (cleanup(); raise e)

fun do_wrap name f pbefore pafter =
  (write " ";
   setb ();  
   write "[";
   write (makestring (!level));
   write "] ";
   write name;
   write "? ";
   setb();
   pbefore();
   endb();
   write "\n";
   level := (!level) + 1;
   let val result = unwind_protect 
   			f
   		        (fn () => level := (!level) - 1)
   in
      level := (!level) - 1;
      write "[";
      write (makestring (!level));
      write "] ";
      write name;
      write ": ";
      pafter(result);
      endb ();
      write "\n";
      result
   end
  )

fun wrap DEBUG name f pbefore pafter =
  if (not (!DEBUG))
    then f()
    else do_wrap name f pbefore pafter;

fun wrapl DEBUGLIST name f pbefore pafter =
  if not (ListUtils.forsome (fn D => !D) DEBUGLIST)
    then f()
    else do_wrap name f pbefore pafter;

end
