(* Plumbing between the lexer and parser *)

signature INTERFACE =
sig

(* The type of locations on streams, used to report error messages *)
type pos
val line : pos ref

(* Called before calling the parser on a new input stream *)
val begin_parser_context : string -> unit

(* Called when a stream has been fully parsed *)
val end_parser_context : unit -> unit

(* Called by the lexer when it scans a \n char *)
val next_line : unit -> unit

(* Called by the parser to report an error *)
val error : string * pos * pos -> unit

end  (* signature INTERFACE *)

