signature LATEXWR = sig

(* A low-level writer abstraction that knows about latex input
   conventions and can switch into and out of verbatim mode as
   appropriate.  See parse.sml for examples. *)

structure Wr: WR

type T

val LATEX_MODE : bool ref; 

(* Build a new latex writer with a given underlying writer, and return 
   both the new latex writer and its "corresponding writer", which allows
   the new latex writer to be viewed as a Wr.T. *)
val to_wr: Wr.Wr -> (Wr.Wr * T)

(* Close a latex writer and its underlying writer *)
val close_lw: T -> unit

(* Start formatting latex text *)
val begintext: T -> unit

(* Finish formatting latex text and go back to verbatim *)
val endtext: T -> unit

end
