signature PARSERES = sig

structure TypHelper: TYPHELPER
structure TrmHelper : TRMHELPER
structure Globals: GLOBALS
sharing TrmHelper.TypHelper = TypHelper
    and TypHelper.Id = Globals.Id
    and TrmHelper.Id = Globals.Id
    and TrmHelper.Globals = Globals
    and TrmHelper.Trm.TypHelper = TypHelper

datatype SystemSpecific = 
    Leq of TypHelper.pretyp * TypHelper.pretyp
  | Type_Assumption of Globals.Id.T * TypHelper.pretyp
  | Type_Abbrev of Globals.Id.T * TypHelper.pretyp
  | Term_Def of Globals.Id.T * TrmHelper.pretrm
  | Term_Assumption of Globals.Id.T * TypHelper.pretyp

datatype Item =
    Specific of SystemSpecific
  | Use of string
  | Set of string * string
  | Cmd of string * (string option)
  | Nothing

datatype T = ITEMS of Item list

end 
