functor ParseRes 
	    (structure TypHelper: TYPHELPER
	     structure TrmHelper: TRMHELPER
	     structure Globals: GLOBALS
	     sharing TypHelper.Globals = Globals
		 and TypHelper.Id = Globals.Id
		 and TrmHelper.Id = Globals.Id
		 and TrmHelper.TypHelper = TypHelper
	         and TrmHelper.Trm.TypHelper = TypHelper
	    ) : PARSERES 
	    = struct

structure TypHelper = TypHelper
structure TrmHelper = TrmHelper
structure Globals = Globals

open TypHelper
open Globals

datatype SystemSpecific = 
    Leq of TypHelper.pretyp * TypHelper.pretyp
  | Type_Assumption of Globals.Id.T * TypHelper.pretyp
  | Type_Abbrev of Globals.Id.T * TypHelper.pretyp
  | Term_Def of Globals.Id.T * TrmHelper.pretrm
  | Term_Assumption of Globals.Id.T * TypHelper.pretyp

datatype Item =
    Specific of SystemSpecific
  | Use of string
  | Set of string * string
  | Cmd of string * (string option)
  | Nothing

datatype T = ITEMS of Item list

end 
