signature TENV = sig

structure Globals: GLOBALS
structure Typ: TYP
sharing Typ.Globals = Globals
include GLOBALS
sharing Id = Globals.Id

type T

val empty: T
val push_bound: T -> Id.T -> Typ.T -> T
val push_abbrev: T -> Id.T -> Typ.T -> T
val push_binding: T -> Id.T -> Typ.T -> T
val pop: T -> T
val popn: T -> int -> T
val domsize: T -> int

exception UnknownId of string
val index: T -> Id.T -> int

val lookup_name: T -> int -> Id.T

val lookup_and_relocate: 
		     T 
                  -> int 
		  -> (Typ.T -> 'a)   (* type variable bound *)
		  -> (Typ.T -> 'a)   (* variable binding *)
		  -> (Typ.T -> 'a)   (* type abbreviation *)
		  -> 'a

val bare_lookup: 
		     T 
                  -> int 
		  -> (Typ.T -> 'a)   (* type variable bound *)
		  -> (Typ.T -> 'a)   (* variable binding *)
		  -> (Typ.T -> 'a)   (* type abbreviation *)
		  -> 'a

exception WrongKindOfId of T * int * string
val lookup_and_relocate_bound: T -> int -> Typ.T
val lookup_and_relocate_binding: T -> int -> Typ.T

end

