signature SYNTH = sig

structure Globals: GLOBALS
structure Trm: TRM
structure Typ: TYP
structure TEnv: TENV
structure TypHelper: TYPHELPER
sharing Trm.Typ = Typ
    and Typ.Globals = Globals
    and TEnv.Typ = Typ
    and TypHelper.Typ = Typ
    and TypHelper.TEnv = TEnv
include GLOBALS

val simplify: TEnv.T -> Typ.T -> Typ.T 
val squash: TEnv.T -> Typ.T -> Typ.T 

val leq: TEnv.T -> Typ.T -> Typ.T -> bool
val eqv: TEnv.T -> Typ.T -> Typ.T -> bool
val samekind: TEnv.T -> Typ.T -> Typ.T -> bool

val synth: TEnv.T -> Trm.T -> Typ.T
exception SynthFailure of unit->unit
exception IllTyped of unit->unit

val ksynth: TEnv.T -> Typ.T -> Typ.K

val setquerytenv: TEnv.T -> unit

end
